#ifndef _CPU_H_
#define _CPU_H_

/* Enables the userspace governor.
 * Returns OKVAL on success or ERRVAL on failure. */
int enable_userspace_governor();

/* Sets the CPU speed.
 * Returns OKVAL if the operation was successful, ERRVAL on failure.*/
int set_speed(int newspeed);

/* Returns the speed the CPU is currently throttled to or ERRVAL on failure. */
int get_speed(void);

/* Returns the current CPU load or -1.0 on failure. */
double get_cpu_load(void);

#endif
