#include <stdio.h>
#include <stdlib.h>

#include <syslog.h>

#include "msg.h"
#include "config.h"

void msg(char *message, int type) {
	FILE *logger = NULL;

	logger = open_log();
	if(logger == stdout) {
		switch(type) {
			case LOG_ERROR:
				printf("ERROR: %s\n", message);
				printf("Exiting...\n");
				break;
			case LOG_WARN:
				printf("warn: %s\n", message);
				break;
			case LOG_NOTE:
				printf("info: %s\n", message);
				break;
			default:
				break;
		}
	} else if(logger == NULL) {
		switch(type) {
			case LOG_ERROR:
				syslog(LOG_ERR, "ERROR: %s\n", message);
				syslog(LOG_ERR, "Exiting...\n");
				break;
			case LOG_WARN:
				syslog(LOG_WARNING, "warn: %s\n", message);
				break;
			case LOG_NOTE:
				syslog(LOG_INFO, "info: %s\n", message);
				break;
			default:
				break;
		}
	}
	close_log(logger);
}

FILE *open_log(void) {
	if(config.daemonize) {
		openlog("autothrottle", LOG_CONS, LOG_DAEMON);
		return NULL;
	} else {
		return stdout;
	}
}

void close_log(FILE *log) {
	if(config.daemonize)
		closelog();
}
